Subject: Re: [PATCH] gitweb: more support for PATH_INFO based URLs

From: Martin Waitz <[email-masked]>
Date: Tue, 19 Sep 2006 10:19:33 +0200

hoi :)

On Sun, Sep 17, 2006 at 04:20:23PM +0200, Jakub Narebski wrote:
> matled (Matthias Lederhofer) on #git proposed to use ':' as a separator
> between branch and filename (as branch doesn't need to be flat, 
> e.g. "jc/diff" like branch name), because valid branch name cannot contain
> ':' (and this limit is only for branch name).

you are right, my patch doesn't work with hierarchical branch names.
However using ":" alone does not work eighter.
My main motivation for this patch was to be able to export .html files
and to have working links between them.
However a <a href="main.html"> link inside "branch:index.html" would
try to get "main.html" and not "branch:main.html".

Perhaps use ":/" as separator?
Or try to add more words to the branch name until we get a valid one.
But I don't know how this plays with Linus' latest ref-pack work
where both "a" and "a/b" are valid branch names (If I understood it
correctly).  Perhaps use a similiar algorith as the one I used
to get the project path?

> He also said that filename doesn't need to be necessary file (which would be
> then present in "blob_plain" view), but it can be also a directory (which
> then would be present in "tree" view). We can either check type using
> git-cat-file -t via git_get_type subroutine, or assume that if we want for
> directory to be shown, it should end with "/".

yes, this was something I wanted to do later, too.

-- 
Martin Waitz